#ifndef FRAME_CPP__CHECKSUM
#define	FRAME_CPP__CHECKSUM

#include "general/types.hh"

namespace FrameCPP
{
  class CheckSum
  {
  public:
    enum kind_type {
      NONE = 0,
      CRC = 1
    };

    CheckSum( const kind_type Type );

    virtual ~CheckSum( );

    kind_type GetType( ) const;

    virtual void calc( const void* Buffer, INT_4U NBytes ) = 0;

    //: Things to be do to complete the calculation
    INT_4U value( );

    virtual CheckSum* Clone( ) const = 0;

  protected:
    INT_4U		m_value;

    CheckSum( const CheckSum& Source );
    virtual void finish( ) = 0;

  private:
    kind_type		m_type;
    CheckSum( );
  };

  inline CheckSum::kind_type CheckSum::
  GetType( ) const
  {
    return m_type;
  }

  inline INT_4U CheckSum::
  value( )
  {
    finish( );
    return m_value;
  }

  class CheckSumCRC: public CheckSum
  {
  public:
    CheckSumCRC( );
    virtual CheckSumCRC* Clone( ) const;

    virtual void calc( const void* Buffer, INT_4U NBytes );

  protected:
    CheckSumCRC( const CheckSumCRC& Source );
    virtual void finish( );

  private:
    static const INT_4U	m_crctab[ 256 ];

    bool		m_active;
    INT_4U		m_number_of_bytes;
  };
}

#endif	/* FRAME_CPP__CHECKSUM */
