#ifndef FRAME_CPP_INTERFACE__FrameHBase_HH
#define FRAME_CPP_INTERFACE__FrameHBase_HH

#include <string>

namespace FrameCPP
{
  class FrAdcDataBase;

  class FrameHBase
  {
  public:
    virtual ~FrameHBase( );

    //-------------------------------------------------------------------
    //: (De)activate an ADC
    //
    // Single ADC channel (de)activated referenced by its name
    //
    //!param: char* adcName - ADC channel name
    //!param: bool activate - true to activate, false to deactivate
    //
    //!exc: not_found_error - ADC channel not found
    //!exc: std::bad_alloc - Memory allocation failed
    //
    virtual void TriggerADC( FrAdcDataBase*, bool activate );

  protected:
    FrameHBase( );
  };



  inline FrameHBase::
  FrameHBase( )
  {
  }

} // namespace FrameCPP

#endif /* FRAME_CPP_INTERFACE__FrameHBase_HH */
