#include "framecpp/config.h"

#include "framecpp/FrameCPP.hh"

#if FRAME_SPEC_CURRENT <= 5

#include "framecpp/framewritertoc.hh"		// Version 3, 4, and 5
#include "framecpp/frameappendwritertoc.hh"	// Version 3, 4, and 5

#include "framecpp/FrameWriterTOC.hh"

using namespace FrameCPP;

FrameWriterTOC::
FrameWriterTOC( std::ostream& Out )
  : m_truncate( new Version::FrameWriterTOC( Out ) ),
    m_append( (Version::FrameAppendWriterTOC*)NULL )
{
}

FrameWriterTOC::
FrameWriterTOC( std::iostream& IOStream, mode_type Mode )
  : m_truncate( ( Mode == TRUNCATE )
		? new Version::FrameWriterTOC( IOStream )
		: (Version::FrameWriterTOC*)NULL ),
    m_append( ( Mode == APPEND )
	      ? new Version::FrameAppendWriterTOC( IOStream )
	      : ( Version::FrameAppendWriterTOC*)NULL )
{
}

FrameWriterTOC::
~FrameWriterTOC( )
{
  delete m_truncate;
  m_truncate = 0;
   
  delete m_append;
  m_append = 0;
}

void FrameWriterTOC::
close( )
{
  if ( m_truncate )
  {
    m_truncate->close( );
  }
  else if ( m_append )
  {
    m_append->close( );
  }
}

void FrameWriterTOC::
writeFrame( const FrameH& Frame )
{
  if ( m_truncate )
  {
    m_truncate->writeFrame( Frame );
  }
  else if ( m_append )
  {
    m_append->writeFrame( Frame );
  }
}

#endif /* FRAME_SPEC_CURRENT <= 5 */
