#include "framecpp/config.h"

#include "base.hh"

using FrameCPP::Version_3_4_5::Base;

   
//-----------------------------------------------------------------------------
//
//: Destructor
//
Base::~Base()
{}
   

//-----------------------------------------------------------------------------
//
//: Give the name for the derived class.
//
//!exc: None.                         
//                                    
std::string Base::getClassName() const
{
  switch ( getClassId() )
    {
    case ID_SH: return "SH";
    case ID_SE: return "SE";
    case ID_FRAME: return "FRAME";
    case ID_ADCDATA: return "ADCDATA";
    case ID_DETECTOR: return "DETECTOR";
    case ID_ENDOFFRAME: return "ENDOFFRAME";
    case ID_MSG: return "MSG";
    case ID_HISTORY: return "HISTORY";
    case ID_RAWDATA: return "RAWDATA";
    case ID_PROCDATA: return "PROCDATA";
    case ID_SIMDATA: return "SIMDATA";
    case ID_SERDATA: return "SERDATA";
    case ID_STATDATA: return "STATDATA";
    case ID_VECT: return "VECT";
    case ID_EVENT: return "EVENT";
    case ID_SUMMARY: return "SUMMARY";
    case ID_ENDOFFILE: return "ENDOFFILE";
    case ID_UNKNOWN: return "UNKNOWN";
    default:
      return "UNKNOWN";
  }
}
