#include "framecpp/config.h"

#include "classinfo.hh"


using FrameCPP::Version_3_4_5::ClassInfo;


//-----------------------------------------------------------------------------
//
//: Default Constructor.
//
//!exc: None.
//      
ClassInfo::ClassInfo()
        : mSH(), mRead( 0 )
{
}


//-----------------------------------------------------------------------------
//
//: Copy constructor.
//
//!param: const ClassInfo& info -
//
//!exc: None.
//      
ClassInfo::ClassInfo( const ClassInfo& info )
        : mSH( info.mSH ), mRead( info.mRead )
{
}


//-----------------------------------------------------------------------------
//
//: Constructor.
//
//!exc: None.
//      
ClassInfo::ClassInfo( const SH& sh, ReadPointer rp )
        : mSH( sh ), mRead( rp )
{
}


//-----------------------------------------------------------------------------
//
//: Assignment Operator.
//
//!param: const ClassInfo& info - Object to be assigned.
//
//!return: const ClassInfo& - This object.
//
//!exc: None.
//      
const ClassInfo& ClassInfo::operator=( const ClassInfo& info )
{
    if ( this != &info )
    {
        mSH = info.mSH;
        mRead = info.mRead;
    }

    return *this;
}

