#ifndef FrameCppDumpHH
#define FrameCppDumpHH

#include <iostream>

namespace FrameCPP
{
  namespace Version_3_4_5 {

    class Frame;
    class AdcData;
    class Detector;
    class Msg;
    class History;
    class RawData;
    class ProcData;    
    class SimData;    
    class SerData;    
    class StatData;    
    class Event;    
    class SimEvent;    
    class Summary;
    class Vect;
    class Table;
  } // namespace - Version_3_4_5

} // namespace - FrameCPP

//: Used for frame file dump
class Indent
{
public:

    Indent( unsigned int i ) 
            : size( i )
        {};

    unsigned int size;
};


std::ostream& operator<<( std::ostream& out, const Indent& indent );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::Frame& fr, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::AdcData& data, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::Detector& data, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::Msg& data, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::History& h, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::RawData& r, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::ProcData& data, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::SimData& data, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::SerData& data, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::StatData& data, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::Event& data, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::SimEvent& data, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::Summary& data, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::Vect& data, unsigned int i = 0 );
void dump( std::ostream& out, FrameCPP::Version_3_4_5::Table& data, unsigned int i = 0 );


#endif // FrameCppDumpHH
