#include "framecpp/config.h"

#include "objectheader.hh"

using FrameCPP::Version_3_4_5::ObjectHeader;


//-----------------------------------------------------------------------------
//
//: Default Constructor.
//
//!todo: Does this need to exist?
//
ObjectHeader::ObjectHeader()
        : mLength( 8 ), mFileClassId( 0 ), mInstance( 0 ), mLocalClassId( 0 )
{
}


//-----------------------------------------------------------------------------
//
//: Constructor.
//
//!param: INT_4U length - Structure length.
//!param: INT_2U fileClass - Structure class ID.
//!param: INT_2U instance - Structure instance number.
//!param: INT_2U localClass - FrameCPP structure class ID.
//
ObjectHeader::ObjectHeader( INT_4U length, INT_2U fileClass, INT_2U instance,
                            INT_2U localClass )
        : mLength( length ), mFileClassId( fileClass ),
          mInstance( instance ), mLocalClassId( localClass )
{
}


//-----------------------------------------------------------------------------
//
//: Copy Constructor.
//
//!param: const ObjectHeader& oh - An object to be copied.
//
ObjectHeader::ObjectHeader( const ObjectHeader& oh )
        : mLength( oh.mLength ), mFileClassId( oh.mFileClassId ),
          mInstance( oh.mInstance ), mLocalClassId( oh.mLocalClassId )
{
}



//-----------------------------------------------------------------------------
// Operator Overloads
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
//
//: Assignment Operator.
//
//!param: const ObjectHeader& oh - An object to be assigned.
//
//!return: const ObjectHeader& - This object.
//
const ObjectHeader& ObjectHeader::operator=( const ObjectHeader& oh )
{
    if ( this != &oh )
    {
        mLength = oh.mLength;
        mFileClassId = oh.mFileClassId;
        mInstance = oh.mInstance;
        mLocalClassId = oh.mLocalClassId;
    }

    return *this;
}


