#include "framecpp/config.h"

#include "reference.hh"
#include "input.hh"

using FrameCPP::Version_3_4_5::Reference;


//-----------------------------------------------------------------------------
//
//: Assignment operator.
//
//!param: const Reference& ref - Object to be assigned.
//
//!return: const Reference& - This object.
//
//!exc: None.   
//      
const Reference& Reference::operator=( const Reference& ref )
{
    mReference = ref.mReference;
    return *this;
}

//-----------------------------------------------------------------------------
//
//: Input extraction operator.
//
//!param: Input& in - Input data stream object.
//!param: Reference& ref - Data target.
//
//!return: Input& - Input data stream object.
//
FrameCPP::Version_3_4_5::Input& FrameCPP::Version_3_4_5::operator>>(
    FrameCPP::Version_3_4_5::Input& in, FrameCPP::Version_3_4_5::Reference& ref )
{
    INT_2U ClassId, Instance;
    in >> ClassId >> Instance;
    ref = Reference(ClassId, Instance);
    return in;
}

