#include "framecpp/config.h"

#ifdef NOT_DEFINED_INSTS

#include "framecpp/Version3_4_5/adcdata.hh"
#include "framecpp/Version3_4_5/detector.hh"
#include "framecpp/Version3_4_5/event.hh"
#include "framecpp/Version3_4_5/history.hh"
#include "framecpp/Version3_4_5/msg.hh"
#include "framecpp/Version3_4_5/procdata.hh"
#include "framecpp/Version3_4_5/serdata.hh"
#include "framecpp/Version3_4_5/searchcontainer.hh"
#include "framecpp/Version3_4_5/simdata.hh"
#include "framecpp/Version3_4_5/simevent.hh"
#include "framecpp/Version3_4_5/statdata.hh"
#include "framecpp/Version3_4_5/summary.hh"
#include "framecpp/Version3_4_5/table.hh"
#include "framecpp/Version3_4_5/vect.hh"

using namespace FrameCPP::Version_3_4_5;

//-----------------------------------------------------------------------
// Instantiate needed Search containers
//-----------------------------------------------------------------------

#ifdef LDAS_OLD_INST

#define INSTANTIATE_2(LM_CLASS,LM_FUNC) \
template class FrameCPP::SearchContainer< LM_CLASS, \
                                          &LM_CLASS::LM_FUNC, \
                                          FrameCPP::Version_3_4_5::Container< LM_CLASS > >
#define INSTANTIATE(LM_CLASS) \
INSTANTIATE_2(LM_CLASS,getName)

#endif



#define INSTANTIATE(C,F) \
template class FrameCPP::Version_3_4_5::Container< C >; \
template class FrameCPP::SearchContainer< C, \
                                          &C::F, \
                                          FrameCPP::Version_3_4_5::Container< C > >

INSTANTIATE( AdcData, getName );
INSTANTIATE( Detector, getName );
INSTANTIATE( Event, getName );
INSTANTIATE( History, getName );
INSTANTIATE( Msg, getAlarm );
INSTANTIATE( ProcData, getName );
INSTANTIATE( SerData, getName );
INSTANTIATE( SimData, getName );
INSTANTIATE( SimEvent, getName );
INSTANTIATE( StatData, getName );
INSTANTIATE( Summary, getName );
INSTANTIATE( Table, getName );
INSTANTIATE( Vect, getName );

#ifdef LDAS_OLD_INST
#undef INSTANTIATE_2
#endif

#undef INSTANTIATE


#endif // NOT_DEFINED_INSTS
