#include "framecpp/config.h"

#include <sstream>

#include "framecpp/Version6/FrCommon.hh"
#include "framecpp/Version6/FrameH.hh"
#include "framecpp/Version6/FrAdcData.hh"
#include "framecpp/Version6/FrDetector.hh"
#include "framecpp/Version6/FrEndOfFile.hh"
#include "framecpp/Version6/FrEndOfFrame.hh"
#include "framecpp/Version6/FrEvent.hh"
#include "framecpp/Version6/FrHistory.hh"
#include "framecpp/Version6/FrMsg.hh"
#include "framecpp/Version6/FrProcData.hh"
#include "framecpp/Version6/FrRawData.hh"
#include "framecpp/Version6/FrSerData.hh"
#include "framecpp/Version6/FrSE.hh"
#include "framecpp/Version6/FrSH.hh"
#include "framecpp/Version6/FrSimData.hh"
#include "framecpp/Version6/FrSimEvent.hh"
#include "framecpp/Version6/FrStatData.hh"
#include "framecpp/Version6/FrSummary.hh"
#include "framecpp/Version6/FrTable.hh"
#include "framecpp/Version6/FrTOC.hh"
#include "framecpp/Version6/FrVect.hh"
#include "framecpp/Version6/STRING.hh"


void FrameCPP::Version_6::AppendComment( 
   std::string& Dest, const std::string& Text )
{
   if( Dest.size() )
   {
      Dest += '\n';
   }

   Dest += Text;
   return;
} 

std::string FrameCPP::Version_6::
GetClassName( INT_4U ClassId )
{
  switch( ClassId )
  {
  case FrBase::CLASS_FR_SE:
      return FrSE::getStaticName( );
  case FrBase::CLASS_FR_SH:
      return FrSH::getStaticName( );
  case CLASS_FRAME_H:
      return FrameH::getStaticName( );
  case CLASS_FR_ADC_DATA:
      return FrAdcData::getStaticName( );
  case CLASS_FR_DETECTOR:
      return FrDetector::getStaticName( );
  case CLASS_FR_END_OF_FILE:
      return FrEndOfFile::getStaticName( );
  case CLASS_FR_END_OF_FRAME:
      return FrEndOfFrame::getStaticName( );
  case CLASS_FR_EVENT:
      return FrEvent::getStaticName( );
  case CLASS_FR_HISTORY:
      return FrHistory::getStaticName( );
  case CLASS_FR_MSG:
      return FrMsg::getStaticName( );
  case CLASS_FR_PROC_DATA:
      return FrProcData::getStaticName( );
  case CLASS_FR_RAW_DATA:
      return FrRawData::getStaticName( );
  case CLASS_FR_SER_DATA:
      return FrSerData::getStaticName( );
  case CLASS_FR_SIM_DATA:
      return FrSimData::getStaticName( );
  case CLASS_FR_SIM_EVENT:
      return FrSimEvent::getStaticName( );
  case CLASS_FR_STAT_DATA:
      return FrStatData::getStaticName( );
  case CLASS_FR_SUMMARY:
      return FrSummary::getStaticName( );
  case CLASS_FR_TABLE:
      return FrTable::getStaticName( );
  case CLASS_FR_TOC:
      return FrTOC::getStaticName( );
  case CLASS_FR_VECT:
      return FrVect::getStaticName( );
  default:
    {
      std::ostringstream	result;

      result << ClassId;
      return result.str( );
    }
    break;
  }
}
