#include "framecpp/config.h"

#include <sstream>

#include "framecpp/Version6/Container.hh"
#include "framecpp/Version6/SearchContainer.hh"

#include "framecpp/Version6/FrAdcData.hh"
#include "framecpp/Version6/FrDetector.hh"
#include "framecpp/Version6/FrEvent.hh"
#include "framecpp/Version6/FrHistory.hh"
#include "framecpp/Version6/FrMsg.hh"
#include "framecpp/Version6/FrProcData.hh"
#include "framecpp/Version6/FrSerData.hh"
#include "framecpp/Version6/FrSimData.hh"
#include "framecpp/Version6/FrSimEvent.hh"
#include "framecpp/Version6/FrStatData.hh"
#include "framecpp/Version6/FrSummary.hh"
#include "framecpp/Version6/FrTable.hh"
#include "framecpp/Version6/FrVect.hh"

#include "framecpp/Container.hh"

using namespace FrameCPP::Version_6;

#define INSTANTIATE( LM_TYPE,LM_FUNC) \
template class FrameCPP::Version_6::Container< LM_TYPE > ; \
template class FrameCPP::SearchContainer< LM_TYPE, &LM_TYPE::LM_FUNC, FrameCPP::Version_6::Container< LM_TYPE > >; \
template class FrameCPP::Version_6::SearchContainer< LM_TYPE, &LM_TYPE::LM_FUNC >

INSTANTIATE( FrAdcData, GetName );
INSTANTIATE( FrDetector, GetName );
INSTANTIATE( FrEvent, GetName );
INSTANTIATE( FrHistory, GetName );
INSTANTIATE( FrMsg, GetAlarm );
INSTANTIATE( FrProcData, GetName );
INSTANTIATE( FrSerData, GetName );
INSTANTIATE( FrSimData, GetName );
INSTANTIATE( FrSimEvent, GetName );
INSTANTIATE( FrStatData, GetName );
INSTANTIATE( FrSummary, GetName );
INSTANTIATE( FrTable, GetName );
INSTANTIATE( FrVect, GetName );
   
#undef INSTANTIATE   
   
