#include "general/config.h"

#include <stdlib.h>
#include <iostream>

#include "general/AtExit.hh"

namespace anonymous
{
  void exit_handler( );
}

extern "C"
{
  typedef void(*atexit_parm_type)();
}

// Instantiate generic to Singleton class methods:   
// see "general" library   
SINGLETON_TS_INST( General::AtExit );   

General::AtExit::exit_function_node* General::AtExit::m_head_function
  = (General::AtExit::exit_function_node*)NULL;
bool General::AtExit::m_is_exiting = false;

General::AtExit::
AtExit( )
{
  (void)atexit( (atexit_parm_type)(singleton_suicide) );
}

General::AtExit::
~AtExit( )
{
  m_is_exiting = true;
  //---------------------------------------------------------------------
  // Delete objects in the reverse order they were created to ensure
  //   object dependencies are maintained.
  //---------------------------------------------------------------------
  while ( m_head_function )
  {
    exit_function_node*	old_head = m_head_function;
    ExitFunction	f = old_head->m_function;

    m_head_function = old_head->m_previous;
    delete old_head;

    (*f)( );
  }
}

void General::AtExit::
Append( ExitFunction Function )
{
  Instance( );	 // Make sure the instance is created.
  m_head_function
    = new exit_function_node( Function, m_head_function );
}
