#ifndef TOSS_HH
#define TOSS_HH

#include <string>

namespace General {

    //: Helper function for throwing standard exceptions
    //!param: cl - the class throwing the exception, as a string
    //!param: fl - the program unit (file name) where the exception is thrown
    //!param: ln - the line number in the program where exception is thrown
    //!param: de - a short description of the exceptional condition
    template<class T>
    void toss(const std::string& cl,
	      const std::string& fl,
	      int                ln,
	      const std::string& de);

} // namespace General

#endif // TOSS_HH
